	bool ErrorMessage(char const *Str); // Defined elsewhere

LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
 const NumEntries = 236;
 PAINTSTRUCT PaintStruct;
 RECT Rect, ClientRect;
 HDC hDC;
 HBRUSH hBrush;
 LOGPALETTE *PLogPalette;
 HPALETTE hPalette;
 int i, j;

 switch(uMsg)
 {
 case WM_PAINT:
  hDC = BeginPaint(hWnd, &PaintStruct);
  GetClientRect(hWnd, &ClientRect);
  PLogPalette = (LOGPALETTE*)LocalAlloc(LPTR, sizeof(LOGPALETTE) +
                                              (NumEntries - 1) * sizeof(PALETTEENTRY));
  PLogPalette -> palVersion = 0x0300;
  PLogPalette -> palNumEntries = NumEntries;
  for(j = 0; j < NumEntries; j ++)
  {
   PLogPalette -> palPalEntry[j].peRed = 2 * j;
   PLogPalette -> palPalEntry[j].peGreen = j;
   PLogPalette -> palPalEntry[j].peBlue = 4 * j;
   PLogPalette -> palPalEntry[j].peFlags = 0x0000;
  }
  hPalette = CreatePalette(PLogPalette);
  if(!hPalette)
   ErrorMessage("CreatePalette Error");
  if(!SelectPalette(hDC, hPalette, false))
   ErrorMessage("SelectPalette Error");
  if(GDI_ERROR == RealizePalette(hDC))
   ErrorMessage("RealizePalette Error");
  for(i = 0; i < 256; i++)
  {
   hBrush = CreateSolidBrush(0x01000000 + i);
   Rect.left = ((ClientRect.right - ClientRect.left) / 18) +
               i % 8 * ((ClientRect.right - ClientRect.left) / 9);
   Rect.top = ((ClientRect.bottom - ClientRect.top) / 72) +
              i / 8 % 32 * ((ClientRect.bottom - ClientRect.top) / 36);
   Rect.right = Rect.left + ((ClientRect.right - ClientRect.left) / 9);
   Rect.bottom = Rect.top + ((ClientRect.bottom - ClientRect.top) / 36);
   FillRect(hDC, &Rect, hBrush);
   DeleteObject(hBrush);
  }
  if(!DeleteObject(hPalette))
   ErrorMessage("DeleteObject Error");
  LocalFree(PLogPalette);
  EndPaint(hWnd, &PaintStruct);
  break;
 case WM_DESTROY:
  PostQuitMessage(0);
  break;
 default:
  return DefWindowProc(hWnd, uMsg, wParam, lParam);
 }
 return 0;
}
